package com.java8.practies;

import java.util.ArrayList;

import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

public class TestEmployee {

	public static void main(String[] args) {

		ArrayList<Employee> list = new ArrayList<Employee>();
		list.add(new Employee("1", "Uma", "Vani", "IT"));
		list.add(new Employee("2", "Sujit", "Krishnan", "CSE"));
		list.add(new Employee("3", "Brayan", "Bra", "IT"));
		list.add(new Employee("4", "Allice", "Ali", "CSE"));

		list.add(new Employee("5", "Sco te", "Scote", "IT"));
		list.add(new Employee("6", "Rajesh", "Krishnan", "ECE"));
		list.add(new Employee("7", "Ramana", "Raju", "IT"));
		list.add(new Employee("8", "Raju", "Krishnan", "EEE"));

		list.add(new Employee("9", "Rishi", "Vani", "IT"));
		list.add(new Employee("10", "Dattu", "Krishnan", "EEE"));

		//1)list of employees, get the first employee from the list and return his fullName
		list.stream().limit(1)
				.forEach(x -> System.out.println("First employee Full Name is::" + x.firstName + x.lastName));

		//given a list of employees. Can you create a map with the count of employees each department has ?
		//with key as department name and count of employees as value.
		Map<String, Long> mapDepartment = list.stream()
				.collect(Collectors.groupingBy(Employee::getDepartmentNames, Collectors.counting()));
		mapDepartment.forEach((k, v) -> System.out.println((k + ":" + v)));

		//Given a map with the department name as key and value as list of employees belonging to that department.
		//when a search string is given, need to list out the employees whose firstname or lastname is matching(match should be case insensitive)
		Map<String, List<Employee>> mapEmployee = list.stream()
				.collect(Collectors.groupingBy(Employee::getDepartmentNames, Collectors.toList()));
		mapEmployee.forEach((k, v) -> System.out.println((k + ":" + v)));

		
		//Consider a list of employees, and if a department name is given as argument, list out the employees which doesn't belong to that department.

		List<Employee> filterEmp = list.stream().filter(x -> !x.getDepartmentNames().equals("IT"))
				.collect(Collectors.toList());
		filterEmp.forEach(x -> System.out.println(" Employee list whose Department is not IT" + x));

		// 6)Consider a list of employees, sort the employees by their firstName and
		// return the sorted list of employees.
		List<Employee> sortedEmployee = list.stream().sorted(new EmployeeComparator()).collect(Collectors.toList());
		sortedEmployee.forEach(x -> System.out.println("Sorted Employee based on firstName" + x));

		//Consider a list of employees, return the employee whose empId is highest
		Employee e = list.stream().max((e1, e2) -> e1.getId().compareTo(e2.getId())).get();
		System.out.println("Maximum Id Employee details" + e);

		//Consider a list of employees, concat the fullName of all the employees with pipe (|) and return the concatenated string.
		String joinedString = list.stream().map(x -> x.firstName + x.lastName).collect(Collectors.joining("|"));
		System.out.println("Maximum Id Employee details-----------" + joinedString);

		//Consider a list of 10 employees, get the 8th employee and print his full name and department name.
		list.stream().sorted((e1, e2) -> e1.getId().compareTo(e2.getId())).skip(8).limit(1)
				.forEach(System.out::println);

		//consider list of employees and list of employee ids. return the list of employees matching with the given list of employee ids.
		List<Employee> checkForMatches = new ArrayList<>();
		checkForMatches.add(new Employee("2", "siri", "raja", "CSE"));
		checkForMatches.add(new Employee("7", "roja", "rani", "CSE"));
		checkForMatches.add(new Employee("11", "roja", "rani", "CSE"));
		

		List<Employee> filteredList = list.stream()
				.filter(employee -> checkForMatches.stream().anyMatch(dept -> employee.getId().equals(dept.getId())))
				.collect(Collectors.toList());

		filteredList.forEach(x -> System.out.println("Employee matches" + x));
		
		//Store ids are of 4 digit strings.if length of given storeId is less than 4 digits,you need to prefix with zeros and return a 4 digit storeId.
		list.stream().forEach(x->System.out.println("4 Digits employee Id::"+String.format("%04d", Integer.parseInt(x.id))));

		
	}

}
